# LXC X-Cash Autoinstaller

Run the LXC Autoinstaller

```sh
rm -f lxc_autoinstaller.sh 2&> /dev/null && wget https://raw.githubusercontent.com/X-CASH-official/xcash-dpops/master/scripts/autoinstaller/lxc_autoinstaller.sh && chmod +x lxc_autoinstaller.sh && ./lxc_autoinstaller.sh
```

![{E1A63E86-014B-4C7C-A5BC-3F16C5AC1354} png](https://user-images.githubusercontent.com/68710094/92037635-5f59d980-ed72-11ea-909c-128aeb20f91e.jpg)

## Short version

Simply run option (1) the first time (to install LXD on your system), then run option (2) to download th x-cash image (using the handle provided below, *Longer Version* section), then run the option (3) to configure your node (creating/importing wallet/keys, setting shared delegate parameters and optionally register your delegate, with all the extra info). Use the other options of the installer to check logs, do maintenance, etc...

> If you come from a traditional node installation, please uninstall your node first (after making the backup of your wallet seed, your wallet password and your delegate private key). You can use the uninstall option of the `autoinstaller.sh` or simply start with a clean Ubuntu 18.04/20.04 installation if it's simpler for you.

## Longer version

First you have to install and configure LXD (if it's the first time you do it). So select the option (1) of the autoinstaller and wait the end of the process

Run the LXC autoinstaller again with `./lxc_autoinstaller.sh` to create the X-Cash container. The best option is to use a pre-built and updated X-Cash image. The autoinstaller supports download with a static URL (using wget) or a fast download from Opacity (encrypted anonymous cloud powered by cryptocurrencies). In the last case (default) the autoinstaller will download a python CLI tool for interacting with Opacity Storage, automatically removed after the download procedure. You have to copy/paste the provided file handle to download the X-Cash image.

Select the option (2) of the LXC autoinstaller.

For the last image generated by n3me5is (updated 2020/09/25) enter the following handle when asked, selecting Opacity as download method:

```
f1af1e270a27a0cde23105b57b555c8d3df0a9375836c91f6540783cce75ed99e97f9abf440d53b596d4b79781c4f06e75d02390ed0392f1392c91b2502a67cd
```

Now you have to create the container and congifure your X-Cash node. All your personal data (keys, wallets...) and DB data (DPOPS database, blockchain LMDB...) will be saved on the host (`xcash-shared-node` folder in the home directory), outside the container. If you update the container, remove it or generate an image to share from it, your personal data will remain on the host and not shared.

Run the LXC autoinstaller again with `./lxc_autoinstaller.sh` and select the option (3). During the procedure the installer will ask you if you want to create a new wallet or import one entering the seed, if you want to create a new password for the wallet or use a personalized one (or the old one) and if you want to create a new validator key or import an existing one. If you already have a node and want to migrate to the X-Cash LXC version, you can simply import everything from your backupped information. During the configuration you have the possibility to download the blockchain snapshot or keep the existing blockchain DB. 

> If you want you can also copy your old data manually into the right folders inside the `xcash-shared-node` folder. Then you have to tun the option (13) of the LXC autoinstaller. Hovever it's suggested to use the standard importing way (option 3, using seed, wallet password and validator private key)

After the installation you can also, optionally, run the delegate registration procedure. If you need to register your new delegate and fill all the extra info (ip, team, server specs, website, about...) follow the procedure when asked. You'll simply have to enter your delegate name, the domain name (or IP) of the delegate and wait! Then you can fill also the exra information. Simply wait the end of the procedure.

> You can modify your info using the option (10) of the LXC autoinstaller and then selection the option (10) of the internal autoinstaller.

After the installation, if you want to check the status of your X-Cash node you can select the option (9) to get an overview (status if the services, wallet balance, blockchain height, delegate statistics). If you want to access more maintenance options, for example to check the logs (wallet, daemon, DPOPS services) you can enter the maintenace script with the option (8).

If you want to monitor the DPOPS log in realtime you can use the option (11) of the LXC autoinstaller. If you want to check DPOPS logs filtering for a word with grep, for example for checking when you was the validator, use the option (12) and enter a search string (case sensitive). For example if your delegate name is "mydelegate" you can enter it to see when you have been selected as validator.

> If you have to modify something manually, you can enter the container shell with the option (7) of the LXC autoinstaller. There you can run all the command you want, update X-Cash, check log files... But pay attention when modifying the service files: since the service files are bind-mounted from the host, you can not use the `sed -i` command, but instead you have to run this `function sed_services() { cat $2 | command sed "$1" | sponge $2; }` and then use `sed_services` instead if `sed -i`.

The X-Cash containter automatically starts on boot (after the firewall) if you reboot the system. You can also manually stop/start the container with options (5) and (6) of the LXC autoinstaller. When you start/stop the container all the X-Cash services inside automatically start/stop.

If you want to update your node you have 2 options:
- Use the option (10) and then select the option (2) in the internal installer to update the X-Cash stuff (traditional way). After the update you can also backup the container generating the image with option (15). The image will contain only OS, dependencies and binaries. All the personal data and DBs are on the Host bind-mounted folders. You have to backup them manually if needed (but keeping your seed, wallet password and validator private key in a safe place is sufficient to recover your node in case of a "issue").
- Use the option (2) of the LXC installer, that will automatically download the X-Cash Image and recreate the container. So the only thing to do is, in case, to provide the updated file handle 

## Creating the X-Cash container from scratch

If you want to create the container from scratch, so start from an empty Ubuntu 18.04 container (preconfigured for installing/running X-Cash node) you can select the option (14). In this case the X-Cash `autoinstaller.sh` is used to install the X-Cash node in the traditional way. After the installation you can create an image from the container with option (15), export it with option (16) and redistribute the file (pre-built image)

> See the script for detailed operations if you want to install all manually

## Animated procedure

In the following GIFs you can see some procedures like installing your node from pre-built image, do maintenance, update delegate information and create your container from scratch to genereate a pre-built image.

**NOTE: The internal autoinstaller can change, so some printed messages/colors could be different in the future. There could be also new features added both in the `autoinstaller.sh` and in the `xcash-maintenance` scripts. Please use the following animated procedures as a guidance. The procedures will always be more or less the same. Always read carefully the autoinstaller warnings and questions if you are using it for the first time.**

### 1,2,3, GO! Install LXC, Download the image, configure the delegate

This shows how to install a X-Cash Shared node starting from a clean Ubuntu 18.04/20.04 installation (on a VPS), using a provided pre-built image and importing the wallet/password/delegate-key. If you need to generate an new wallet/key, the procedure is very similar.

**Install LXC**

![lxc_install](https://user-images.githubusercontent.com/68710094/93710498-a5bb8080-fb47-11ea-9eb1-49e4a61b2595.gif)

**Download/Update the pre-built image**

![image_download_import](https://user-images.githubusercontent.com/68710094/93710507-c257b880-fb47-11ea-8c3b-b61604d55aec.gif)

**Configure the delegate node**

![configure_delegate](https://user-images.githubusercontent.com/68710094/93710514-d8657900-fb47-11ea-89cb-ceebcbac50c4.gif)

**Optionally Update your delegate info (about, team, IP, server specs...)**

![update_delegate_info](https://user-images.githubusercontent.com/68710094/93710543-ffbc4600-fb47-11ea-91e8-8581e67ad533.gif)

**Install the Firewall on the Host**

![install_firewall_host](https://user-images.githubusercontent.com/68710094/93711081-89214780-fb4b-11ea-91fb-0a98380cc313.gif)

### Update the delegate

You can **update simply downloading a new pre-built image when available (using option 2)**, the new container will be recreated (if already exists) without touching your configuration/DB/wallet. **See the "Download/Update the pre-built image" above**. 

If you need to do **small updates without re-downloading the whole image**, sometimes is faster to run the **legacy updater** inside the container (using the `autoinstaller.sh`). See how in this GIF.

![manual_update_inside_container](https://user-images.githubusercontent.com/68710094/93710692-e36cd900-fb48-11ea-85f9-d262cb5ee807.gif)

### Maintenance

Using the maintenance script inside the container, checking logs, node status, DPOPS log and so on using a simple interface. Entering the container and execute commands if needed (for example modifying service files manually).

![maintenance_and_debug](https://user-images.githubusercontent.com/68710094/93710804-8b82a200-fb49-11ea-8cc8-687ed645fd41.gif)

### Creating the container from scratch end exporting a new pre-built image

You can create the container starting from a clean Ubuntu 18.04 base image, installing everything with the `autoinstaller.sh` in the usual way. The procedure is more or less the same of installing in the Host, except you don't install the firewall inside the container. See the procedure.

![create_container_from_scratch](https://user-images.githubusercontent.com/68710094/93710864-0c419e00-fb4a-11ea-90d2-e45f57f9c3f7.gif)

You can then create the image from the container (used as backup system or to redistribute it, if you do the export)

![create_export_image](https://user-images.githubusercontent.com/68710094/93710887-309d7a80-fb4a-11ea-94e0-d88317426a2e.gif)

### Uninstalling

The GIF shows how to uninstall only certain things (for maintenance/debug, in the example p2p peers and lmdb) and how to remove X-Cash image, X-Cash container, personal data, LXC packages. You can purge all or remove only what needed.

![uninstall_lxd_installer](https://user-images.githubusercontent.com/68710094/93711200-a276c380-fb4c-11ea-8d2f-8e5164d707cc.gif)


## A note about Opacity File Handle and Opacity CLI tool

For the download image option the scripts support 2 method: using Opacity Storage or downloading the `tar.gz` image directly from a provided (or the default, if any) URL. The user can select the method he prefers (or the method suggested by X-Cash team). Remember to download the image only from an official mirror/handle or from a trusted one (eg. trusted community member). 

Opacity Storage is a cloud (currently centralized) anonymous storage service powered by the OPQ (Opacity) cryptocurrency (ERC-20). No personal information are required for using the service (when opening the account), only the OPQ transaction to buy the yearly storage plans. The download/upload speed is very good (Amazon backends) and the files are encrypted/decrypted client side (and divided into chunks). Each file handle is a unique identifier pointing to a shared file, download will be always free. Opacity Storage is an Open Source project managed by a young and small startup but with a clear vision about the importance of the privacy.

During the download process, if Opacity method is chosen, a python Opacity-CLI client will be download, used to download and decrypt the image file and then deleted. This Opacity-CLI client is a modified version of a community developed unofficial client supporting big file sizes, and it's used to download the image (providing the handle) in a faster way. The Opacity-CLI client used by the script is this one: https://github.com/n3me5is-git/opacity-cly-py. 

With Opacity Storage you can serve big files (like pre-built images, blockchain snapsots...) without using your server and paying high costs for the bandwidth if many users need to download the file (quickly). However you have the option to don't use the Opacity downloader and provide the http URL of the image, downloading it in the standard way.
